using System;
using System.Collections.Generic;
using UnityEngine;
using UnityEditor;
using SimpleJSON;
using System.Collections;
using UnityEngine.Events;
using UnityEngine.UI;
using Random=UnityEngine.Random;

/* 95% written by MeshedVR
Doc'0c adapted it to a plugin
*/
namespace ReVAMped
{

    public class WindControl : MVRScript
    {
        Atom windDirection;
        public static Vector3 globalWind = Vector3.zero;
        protected Vector3  newDirection = Vector3.zero;
        protected Vector3 newTargetDirection = new Vector3();
        protected string _missingReceiverStoreId = string.Empty;
        public bool isHair;
        public bool isCloth;
		public bool isAvatar;
        public bool pushAvatar;
        public bool quicknessRatioToggle;
        public bool periodRatioToggle;
        public bool isTornado;
        public bool isTornadoClock;
        public bool isRadial;
        public bool isRadialIntensity;
        public bool isBlowing;
        public bool isBySpeed;
        public bool isByRotation;
        public bool sliderMagnitudeMatch;
        public bool oscillation=false;
        public bool penisControlEnabled;
        public bool directionDebug;
        protected float windRandomX;
        protected float windRandomY;
        protected float windRandomZ;
        protected float RandomPush;
        protected JSONStorableBool isHairJSON;
        protected JSONStorableBool isClothJSON;
		protected JSONStorableBool isAvatarJSON;
        protected JSONStorableBool pushAvatarJSON;
        protected JSONStorableBool isTornadoJSON;
        protected JSONStorableBool isTornadoClockJSON;
        protected JSONStorableBool isBlowingJSON;
        protected JSONStorableBool isBySpeedJSON;
        protected JSONStorableBool isByRotationJSON;
        protected JSONStorableBool sliderMagnitudeMatchJSON; 
        protected Atom receivingAtom;
        protected Atom receivingSlider;
        protected JSONStorableStringChooser atomJSON;
        protected JSONStorableStringChooser receivingSliderJSON;
        protected JSONStorable receiver;
        protected JSONStorableStringChooser receiverJSON;
        protected JSONStorableStringChooser slider_receiverJSON;
        protected string _receiverTargetName;
        protected JSONStorableVector3 receiverTarget;
        protected JSONStorableStringChooser receiverTargetJSON;
        protected JSONStorableFloat topSliderMagnitudeJSON;
        protected JSONStorableFloat bottomSliderMagnitudeJSON;
        protected JSONStorableFloat currentMagnitudeJSON;
        protected JSONStorableBool randomWindSpeedJSON;
        protected JSONStorableBool oscillatingJSON;
        protected JSONStorableFloat periodJSON;
        protected JSONStorableFloat quicknessJSON;
        protected JSONStorableFloat windDecay;
        protected JSONStorableFloat avatarMobility;
        protected JSONStorableFloat windStrength;
        protected JSONStorableFloat windTurbulence;
        protected JSONStorableFloat speedThreshold;
        protected JSONStorableFloat speedQuickness;
        protected JSONStorableFloat speedMultiplier;
        protected JSONStorableFloat targetMagnitudeJSON;
        protected JSONStorableFloat lowerMagnitudeJSON;
        protected JSONStorableFloat lowerMagnitudeRatioJSON;
        protected JSONStorableFloat quicknessRatioJSON;
        protected JSONStorableFloat periodRatioJSON;
        protected JSONStorableFloat penisControlMobility;
        protected JSONStorableBool quicknessRatioToggleJSON;
        protected JSONStorableBool periodRatioToggleJSON;
        protected JSONStorableFloat oscillationVariance;
        protected JSONStorableFloat upperMagnitudeJSON;
        protected JSONStorableBool directionDebugJSON;
        protected float timer;
        protected Vector3 direction;
        protected Dictionary<string, ForceReceiver> receiverNameToForceReceiver;
        protected Rigidbody RB;
        protected UIDynamicButton btn;
        protected string _lastBrowseDir;

        protected JSONStorableFloat mobility_penis;
        protected JSONStorableFloat mobility_strong;
        protected JSONStorableFloat mobility_midhigh;
        protected JSONStorableFloat mobility_midlow;
        protected JSONStorableFloat mobility_medium;
        protected JSONStorableFloat mobility_light;
        protected JSONStorableFloat mobility_controller;

        protected JSONStorableBool isRadialJSON;
        protected JSONStorableBool isRadialIntensityJSON;

        protected Dictionary<string, bool> RB_enabled;
        protected Dictionary<string, JSONStorableFloat> RB_mobility;
        protected Dictionary<string, FreeControllerV3> Controllers;
        protected Dictionary<string, GameObject> bodyDirectionDebug;
        protected Dictionary<string, LineRenderer> bodyLineDebug;
        protected Dictionary<string, Vector3> controllerWindForce;
        protected Dictionary<string, Vector3> newWindDirections;
        protected Dictionary<string, float> timers;
        

        protected float timer2=0;
        protected float timer3=0;
        protected float speed;
        protected float oldSpeed;

        protected JSONStorableFloat customJSON;
        protected JSONStorableFloat xRotation;

        protected JSONStorableBool randomHairUndo_toggle_JSON;
        protected bool randomHairUndo_toggle=false;
        protected JSONStorableFloat randomHairUndo_threshold_JSON;
        protected JSONStorableFloat randomHairUndoVal_JSON;
        protected JSONStorableFloat randomHairUndoDecrement_JSON;

        private LineRenderer _lineRenderer;
        private Vector3[] _linePoints;

        protected void SyncReceiverRB(string receiver)
        {
            if (receiver != null)
            {
                ForceReceiver fr;
                if (receiverNameToForceReceiver.TryGetValue(receiver, out fr))
                {
                    RB = fr.GetComponent<Rigidbody>();
                }
                else
                {
                    RB = null;
                }
            }
            else
            {
                RB = null;
            }
        }

        protected void initRBdicts()
        {
            RB_enabled = new Dictionary<string, bool>();
            RB_mobility = new Dictionary<string, JSONStorableFloat>();
            bodyDirectionDebug = new Dictionary<string,GameObject>();
            bodyLineDebug = new Dictionary<string,LineRenderer>();
            controllerWindForce = new Dictionary<string,Vector3>();
            newWindDirections = new Dictionary<string,Vector3>();
            timers = new Dictionary<string, float>();

            mobility_penis=new JSONStorableFloat("mobility_penis", 0.1f, 0.1f, 1.0f, true, true);
            mobility_light=new JSONStorableFloat("mobility_light", 1f, 0.1f, 1.0f, true, true);
            mobility_strong=new JSONStorableFloat("mobility_strong", 0.1f, 0.1f, 1.0f, true, true);
            mobility_medium=new JSONStorableFloat("mobility_medium", 0.5f, 0.1f, 1.0f, true, true);
            mobility_midhigh=new JSONStorableFloat("mobility_midhigh", 0.25f, 0.1f, 1.0f, true, true);
            mobility_midlow=new JSONStorableFloat("mobility_midlow", 0.75f, 0.1f, 1.0f, true, true);
            mobility_controller=new JSONStorableFloat("mobility_controller", 0.1f, 0.1f, 1.0f, true, true);
        }

        protected void SetDefaultRBmobility()
        {
            RB_mobility.Add("control",mobility_light);
            RB_mobility.Add("rNipple",mobility_midhigh);
            RB_mobility.Add("lNipple",mobility_midhigh);
            RB_mobility.Add("pelvis",mobility_midhigh);
            RB_mobility.Add("hip",mobility_midhigh);
            RB_mobility.Add("rThigh",mobility_midhigh);
            RB_mobility.Add("lThigh",mobility_midhigh);
            RB_mobility.Add("rShin",mobility_midhigh);
            RB_mobility.Add("lShin",mobility_midhigh);
            RB_mobility.Add("rFoot",mobility_controller);
            RB_mobility.Add("lFoot",mobility_controller);
            RB_mobility.Add("LGlute",mobility_midhigh);
            RB_mobility.Add("RGlute",mobility_midhigh);
            RB_mobility.Add("abdomen",mobility_midhigh);
            RB_mobility.Add("abdomen2",mobility_midhigh);
            RB_mobility.Add("chest",mobility_midhigh);
            RB_mobility.Add("rCollar",mobility_midhigh);
            RB_mobility.Add("lCollar",mobility_midhigh);
            RB_mobility.Add("rShldr",mobility_midhigh);
            RB_mobility.Add("lShldr",mobility_midhigh);
            RB_mobility.Add("rForeArm",mobility_midhigh);
            RB_mobility.Add("lForeArm",mobility_midhigh);
            RB_mobility.Add("rHand",mobility_controller);
            RB_mobility.Add("lHand",mobility_controller);
            RB_mobility.Add("rPectoral",mobility_midhigh);
            RB_mobility.Add("lPectoral",mobility_midhigh);
            RB_mobility.Add("neck",mobility_midhigh);
            RB_mobility.Add("head",mobility_midhigh);
        }

        protected void SetDefaultRBenabled()
        {
            RB_enabled.Add("control",false);
            RB_enabled.Add("rNipple",false);
            RB_enabled.Add("lNipple",false);
            RB_enabled.Add("pelvis",false);
            RB_enabled.Add("hip",false);
            RB_enabled.Add("rThigh",false);
            RB_enabled.Add("lThigh",false);
            RB_enabled.Add("rShin",false);
            RB_enabled.Add("lShin",false);
            RB_enabled.Add("rFoot",false);
            RB_enabled.Add("lFoot",false);
            RB_enabled.Add("LGlute",false);
            RB_enabled.Add("RGlute",false);
            RB_enabled.Add("abdomen",false);
            RB_enabled.Add("abdomen2",false);
            RB_enabled.Add("chest",false);
            RB_enabled.Add("rCollar",false);
            RB_enabled.Add("lCollar",false);
            RB_enabled.Add("rShldr",false);
            RB_enabled.Add("lShldr",false);
            RB_enabled.Add("rForeArm",false);
            RB_enabled.Add("lForeArm",false);
            RB_enabled.Add("rHand",false);
            RB_enabled.Add("lHand",false);
            RB_enabled.Add("rPectoral",false);
            RB_enabled.Add("lPectoral",false);
            RB_enabled.Add("neck",false);
            RB_enabled.Add("head",false);
        }

        protected void RBpreset_disableAll()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=false;
            this.GetBoolJSONParam("lNipple RigidBody").val=false;
            this.GetBoolJSONParam("pelvis RigidBody").val=false;
            this.GetBoolJSONParam("hip RigidBody").val=false;
            this.GetBoolJSONParam("rThigh RigidBody").val=false;
            this.GetBoolJSONParam("lThigh RigidBody").val=false;
            this.GetBoolJSONParam("rShin RigidBody").val=false;
            this.GetBoolJSONParam("lShin RigidBody").val=false;
            this.GetBoolJSONParam("rFoot RigidBody").val=false;
            this.GetBoolJSONParam("lFoot RigidBody").val=false;
            this.GetBoolJSONParam("LGlute RigidBody").val=false;
            this.GetBoolJSONParam("RGlute RigidBody").val=false;
            this.GetBoolJSONParam("abdomen RigidBody").val=false;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=false;
            this.GetBoolJSONParam("chest RigidBody").val=false;
            this.GetBoolJSONParam("rCollar RigidBody").val=false;
            this.GetBoolJSONParam("lCollar RigidBody").val=false;
            this.GetBoolJSONParam("rShldr RigidBody").val=false;
            this.GetBoolJSONParam("lShldr RigidBody").val=false;
            this.GetBoolJSONParam("rForeArm RigidBody").val=false;
            this.GetBoolJSONParam("lForeArm RigidBody").val=false;
            this.GetBoolJSONParam("rHand RigidBody").val=false;
            this.GetBoolJSONParam("lHand RigidBody").val=false;
            this.GetBoolJSONParam("rPectoral RigidBody").val=false;
            this.GetBoolJSONParam("lPectoral RigidBody").val=false;
            this.GetBoolJSONParam("neck RigidBody").val=false;
            this.GetBoolJSONParam("head RigidBody").val=false;
        }

        protected void RBpreset_enableAll()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=true;
            this.GetBoolJSONParam("lNipple RigidBody").val=true;
            this.GetBoolJSONParam("pelvis RigidBody").val=true;
            this.GetBoolJSONParam("hip RigidBody").val=true;
            this.GetBoolJSONParam("rThigh RigidBody").val=true;
            this.GetBoolJSONParam("lThigh RigidBody").val=true;
            this.GetBoolJSONParam("rShin RigidBody").val=true;
            this.GetBoolJSONParam("lShin RigidBody").val=true;
            this.GetBoolJSONParam("rFoot RigidBody").val=true;
            this.GetBoolJSONParam("lFoot RigidBody").val=true;
            this.GetBoolJSONParam("LGlute RigidBody").val=true;
            this.GetBoolJSONParam("RGlute RigidBody").val=true;
            this.GetBoolJSONParam("abdomen RigidBody").val=true;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=true;
            this.GetBoolJSONParam("chest RigidBody").val=true;
            this.GetBoolJSONParam("rCollar RigidBody").val=true;
            this.GetBoolJSONParam("lCollar RigidBody").val=true;
            this.GetBoolJSONParam("rShldr RigidBody").val=true;
            this.GetBoolJSONParam("lShldr RigidBody").val=true;
            this.GetBoolJSONParam("rForeArm RigidBody").val=true;
            this.GetBoolJSONParam("lForeArm RigidBody").val=true;
            this.GetBoolJSONParam("rHand RigidBody").val=true;
            this.GetBoolJSONParam("lHand RigidBody").val=true;
            this.GetBoolJSONParam("rPectoral RigidBody").val=true;
            this.GetBoolJSONParam("lPectoral RigidBody").val=true;
            this.GetBoolJSONParam("neck RigidBody").val=true;
            this.GetBoolJSONParam("head RigidBody").val=true;
        }

        protected void RBpreset_enableAll_noHands()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=true;
            this.GetBoolJSONParam("lNipple RigidBody").val=true;
            this.GetBoolJSONParam("pelvis RigidBody").val=true;
            this.GetBoolJSONParam("hip RigidBody").val=true;
            this.GetBoolJSONParam("rThigh RigidBody").val=true;
            this.GetBoolJSONParam("lThigh RigidBody").val=true;
            this.GetBoolJSONParam("rShin RigidBody").val=true;
            this.GetBoolJSONParam("lShin RigidBody").val=true;
            this.GetBoolJSONParam("rFoot RigidBody").val=true;
            this.GetBoolJSONParam("lFoot RigidBody").val=true;
            this.GetBoolJSONParam("LGlute RigidBody").val=true;
            this.GetBoolJSONParam("RGlute RigidBody").val=true;
            this.GetBoolJSONParam("abdomen RigidBody").val=true;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=true;
            this.GetBoolJSONParam("chest RigidBody").val=true;
            this.GetBoolJSONParam("rCollar RigidBody").val=true;
            this.GetBoolJSONParam("lCollar RigidBody").val=true;
            this.GetBoolJSONParam("rShldr RigidBody").val=true;
            this.GetBoolJSONParam("lShldr RigidBody").val=true;
            this.GetBoolJSONParam("rForeArm RigidBody").val=true;
            this.GetBoolJSONParam("lForeArm RigidBody").val=true;
            this.GetBoolJSONParam("rHand RigidBody").val=false;
            this.GetBoolJSONParam("lHand RigidBody").val=false;
            this.GetBoolJSONParam("rPectoral RigidBody").val=true;
            this.GetBoolJSONParam("lPectoral RigidBody").val=true;
            this.GetBoolJSONParam("neck RigidBody").val=true;
            this.GetBoolJSONParam("head RigidBody").val=true;
        }

        protected void RBpreset_enableAll_noFeet()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=true;
            this.GetBoolJSONParam("lNipple RigidBody").val=true;
            this.GetBoolJSONParam("pelvis RigidBody").val=true;
            this.GetBoolJSONParam("hip RigidBody").val=true;
            this.GetBoolJSONParam("rThigh RigidBody").val=true;
            this.GetBoolJSONParam("lThigh RigidBody").val=true;
            this.GetBoolJSONParam("rShin RigidBody").val=true;
            this.GetBoolJSONParam("lShin RigidBody").val=true;
            this.GetBoolJSONParam("rFoot RigidBody").val=false;
            this.GetBoolJSONParam("lFoot RigidBody").val=false;
            this.GetBoolJSONParam("LGlute RigidBody").val=true;
            this.GetBoolJSONParam("RGlute RigidBody").val=true;
            this.GetBoolJSONParam("abdomen RigidBody").val=true;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=true;
            this.GetBoolJSONParam("chest RigidBody").val=true;
            this.GetBoolJSONParam("rCollar RigidBody").val=true;
            this.GetBoolJSONParam("lCollar RigidBody").val=true;
            this.GetBoolJSONParam("rShldr RigidBody").val=true;
            this.GetBoolJSONParam("lShldr RigidBody").val=true;
            this.GetBoolJSONParam("rForeArm RigidBody").val=true;
            this.GetBoolJSONParam("lForeArm RigidBody").val=true;
            this.GetBoolJSONParam("rHand RigidBody").val=true;
            this.GetBoolJSONParam("lHand RigidBody").val=true;
            this.GetBoolJSONParam("rPectoral RigidBody").val=true;
            this.GetBoolJSONParam("lPectoral RigidBody").val=true;
            this.GetBoolJSONParam("neck RigidBody").val=true;
            this.GetBoolJSONParam("head RigidBody").val=true;
        }

        protected void RBpreset_enableAll_noHandsFeet()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=true;
            this.GetBoolJSONParam("lNipple RigidBody").val=true;
            this.GetBoolJSONParam("pelvis RigidBody").val=true;
            this.GetBoolJSONParam("hip RigidBody").val=true;
            this.GetBoolJSONParam("rThigh RigidBody").val=true;
            this.GetBoolJSONParam("lThigh RigidBody").val=true;
            this.GetBoolJSONParam("rShin RigidBody").val=true;
            this.GetBoolJSONParam("lShin RigidBody").val=true;
            this.GetBoolJSONParam("rFoot RigidBody").val=false;
            this.GetBoolJSONParam("lFoot RigidBody").val=false;
            this.GetBoolJSONParam("LGlute RigidBody").val=true;
            this.GetBoolJSONParam("RGlute RigidBody").val=true;
            this.GetBoolJSONParam("abdomen RigidBody").val=true;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=true;
            this.GetBoolJSONParam("chest RigidBody").val=true;
            this.GetBoolJSONParam("rCollar RigidBody").val=true;
            this.GetBoolJSONParam("lCollar RigidBody").val=true;
            this.GetBoolJSONParam("rShldr RigidBody").val=true;
            this.GetBoolJSONParam("lShldr RigidBody").val=true;
            this.GetBoolJSONParam("rForeArm RigidBody").val=true;
            this.GetBoolJSONParam("lForeArm RigidBody").val=true;
            this.GetBoolJSONParam("rHand RigidBody").val=false;
            this.GetBoolJSONParam("lHand RigidBody").val=false;
            this.GetBoolJSONParam("rPectoral RigidBody").val=true;
            this.GetBoolJSONParam("lPectoral RigidBody").val=true;
            this.GetBoolJSONParam("neck RigidBody").val=true;
            this.GetBoolJSONParam("head RigidBody").val=true;
        }

        protected void RBpreset_enableMain()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=true;
            this.GetBoolJSONParam("lNipple RigidBody").val=true;
            this.GetBoolJSONParam("pelvis RigidBody").val=false;
            this.GetBoolJSONParam("hip RigidBody").val=true;
            this.GetBoolJSONParam("rThigh RigidBody").val=true;
            this.GetBoolJSONParam("lThigh RigidBody").val=true;
            this.GetBoolJSONParam("rShin RigidBody").val=false;
            this.GetBoolJSONParam("lShin RigidBody").val=false;
            this.GetBoolJSONParam("rFoot RigidBody").val=false;
            this.GetBoolJSONParam("lFoot RigidBody").val=false;
            this.GetBoolJSONParam("LGlute RigidBody").val=true;
            this.GetBoolJSONParam("RGlute RigidBody").val=true;
            this.GetBoolJSONParam("abdomen RigidBody").val=false;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=false;
            this.GetBoolJSONParam("chest RigidBody").val=true;
            this.GetBoolJSONParam("rCollar RigidBody").val=false;
            this.GetBoolJSONParam("lCollar RigidBody").val=false;
            this.GetBoolJSONParam("rShldr RigidBody").val=false;
            this.GetBoolJSONParam("lShldr RigidBody").val=false;
            this.GetBoolJSONParam("rForeArm RigidBody").val=false;
            this.GetBoolJSONParam("lForeArm RigidBody").val=false;
            this.GetBoolJSONParam("rHand RigidBody").val=false;
            this.GetBoolJSONParam("lHand RigidBody").val=false;
            this.GetBoolJSONParam("rPectoral RigidBody").val=true;
            this.GetBoolJSONParam("lPectoral RigidBody").val=true;
            this.GetBoolJSONParam("neck RigidBody").val=true;
            this.GetBoolJSONParam("head RigidBody").val=true;
        }

        protected void RBpreset_floatVal()
        {
            this.GetFloatJSONParam("control Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("rNipple Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("lNipple Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("pelvis Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("hip Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("rThigh Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("lThigh Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("rShin Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("lShin Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("rFoot Mobility").val=mobility_controller.val;
            this.GetFloatJSONParam("lFoot Mobility").val=mobility_controller.val;
            this.GetFloatJSONParam("LGlute Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("RGlute Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("abdomen Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("abdomen2 Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("chest Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("rCollar Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("lCollar Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("rShldr Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("lShldr Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("rForeArm Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("lForeArm Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("rHand Mobility").val=mobility_controller.val;
            this.GetFloatJSONParam("lHand Mobility").val=mobility_controller.val;
            this.GetFloatJSONParam("rPectoral Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("lPectoral Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("neck Mobility").val=mobility_midhigh.val;
            this.GetFloatJSONParam("head Mobility").val=mobility_midhigh.val;

        }

        protected void debug_print_dictionary()
        {
            //var foundCanvasObjects = FindObjectsOfType<LineRenderer>();
            SuperController.LogMessage("Printing bodyLineDebug");
            foreach(KeyValuePair<string,LineRenderer> elem in bodyLineDebug){
                SuperController.LogMessage("key:"+elem.Key+" val:"+elem.Value+"");
            }
        }

        protected void SyncIsHair(bool b)
        {
            turnWindOff_Hair();
            isHair = b;
        }

        protected void SyncIsCloth(bool b)
        {
            turnWindOff_Clothes();
            isCloth = b;
        }
		
		protected void SyncIsAvatar(bool b)
        {
            isAvatar = b;
            if(b)
            {
                toggleDebugLines(true);
            }
            else
            {
                toggleDebugLines(false);
            }
        }

        protected void SyncPushAvatar(bool b)
        {
            pushAvatar = b;
        }

        protected void SyncQuicknessRatioToggle(bool b)
        {
            quicknessRatioToggle = b;
        }

        protected void SyncPeriodRatioToggle(bool b)
        {
            periodRatioToggle = b;
        }

        protected void SyncIsTornado(bool b)
        {
            isTornado = b;
        }

        protected void SyncIsTornadoClock(bool b)
        {
            isTornadoClock = b;
        }

        protected void SyncIsBlowing(bool b)
        {
            isBlowing = b;
        }

        protected void SyncIsBySpeed(bool b)
        {
            isBySpeed = b;
        }

        protected void SyncIsByRotation(bool b)
        {
            isByRotation = b;
        }

        protected void SyncIsRadial(bool b)
        {
            isRadial = b;
        }

        protected void SyncIsRadialIntensity(bool b)
        {
            isRadialIntensity = b;
        }

        protected void SyncSliderMagnitudeMatch(bool b)
        {
            sliderMagnitudeMatch = b;
        }

        protected void SyncDirectionDebug(bool b)
        {
            directionDebug = b;
            
            if(b)
            {
                initLineRenderer();
                toggleDebugLines(true);
            }
            else
            {
                Destroy(_lineRenderer);
                toggleDebugLines(false);
            }
            //showAllLinesObj();
            
        }

         //receivingAtom functions
        protected void SyncAtomChoices()
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            foreach (string atomUiD in SuperController.singleton.GetAtomUIDs())
            {
                var temp = SuperController.singleton.GetAtomByUid(atomUiD);
                if(temp.type == "Person")
                {
                    stringList.Add(atomUiD);
                }   
            }
            atomJSON.choices = stringList;
        }

        protected void OnAtomRename(string oldid, string newid)
        {
            SyncAtomChoices();
            if (atomJSON == null || !(receivingAtom != null))
                return;
            atomJSON.valNoCallback = receivingAtom.uid;
        }

        protected void SyncAtom(string atomUID)
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            if (atomUID != null)
            {
                receivingAtom = SuperController.singleton.GetAtomByUid(atomUID);
                if (receivingAtom != null)
                {
                    foreach (string storableId in receivingAtom.GetStorableIDs())
                    {
                        stringList.Add(storableId);
                    }
                    receiverNameToForceReceiver = new Dictionary<string, ForceReceiver>();
                    foreach (ForceReceiver fr in receivingAtom.forceReceivers)
                    {
                        receiverNameToForceReceiver.Add(fr.name, fr);
                    }
                }
            }
            else
                receivingAtom = (Atom)null;

            receiverJSON.choices = stringList;
            receiverJSON.val = "None";
        }

        protected void CheckMissingReceiver()
        {
            if (!(_missingReceiverStoreId != string.Empty)
                || !(receivingAtom != null)
                || !(receivingAtom.GetStorableByID(_missingReceiverStoreId) != null))
                return;

            string receiverTargetName = _receiverTargetName;
            SyncReceiver(_missingReceiverStoreId);
            _missingReceiverStoreId = string.Empty;
            insideRestore = true;
            receiverTargetJSON.val = receiverTargetName;
            insideRestore = false;
        }

        protected void SyncReceiver(string receiverID)
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            if (receivingAtom != null && receiverID != null)
            {
                receiver = receivingAtom.GetStorableByID(receiverID);
                if (receiver != null)
                {
                    foreach (string vector3ParamName in receiver.GetVector3ParamNames())
                    {
                        stringList.Add(vector3ParamName);
                    }
                }
                else if (receiverID != "None")
                    _missingReceiverStoreId = receiverID;
            }
            else
            {
                receiver = null;
            }

            receiverTargetJSON.choices = stringList;
            receiverTargetJSON.val = "None";
        }

        //receivingSlider functions
        protected void SyncAtomChoices_slider()
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            foreach (string atomUiD in SuperController.singleton.GetAtomUIDs())
            {
                var temp = SuperController.singleton.GetAtomByUid(atomUiD);
                if(temp.type == "UISlider")
                {
                    stringList.Add(atomUiD);
                }   
            }
            receivingSliderJSON.choices = stringList;
        }
        protected void OnAtomRename_slider(string oldid, string newid)
        {
            SyncAtomChoices_slider();
            if (receivingSliderJSON == null || !(receivingSlider != null))
                return;
            receivingSliderJSON.valNoCallback = receivingSlider.uid;
        }

        protected void SyncAtom_slider(string atomUID)
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            if (atomUID != null)
            {
                receivingSlider = SuperController.singleton.GetAtomByUid(atomUID);
                if (receivingSlider != null)
                {
                    foreach (string storableId in receivingSlider.GetStorableIDs())
                    {
                        stringList.Add(storableId);
                    }
                }
            }
            else
                receivingSlider = (Atom)null;

            slider_receiverJSON.choices = stringList;
            slider_receiverJSON.val = "None";
        }

        protected void CheckMissingReceiver_slider()
        {
            if (!(_missingReceiverStoreId != string.Empty)
                || !(receivingSlider != null)
                || !(receivingSlider.GetStorableByID(_missingReceiverStoreId) != null))
                return;

            string receiverTargetName = _receiverTargetName;
            SyncReceiver(_missingReceiverStoreId);
            _missingReceiverStoreId = string.Empty;
            insideRestore = true;
            receiverTargetJSON.val = receiverTargetName;
            insideRestore = false;
        }

        protected void SyncReceiver_slider(string receiverID)
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            if (receivingSlider != null && receiverID != null)
            {
                receiver = receivingSlider.GetStorableByID(receiverID);
                if (receiver != null)
                {
                    foreach (string vector3ParamName in receiver.GetVector3ParamNames())
                    {
                        stringList.Add(vector3ParamName);
                    }
                }
                else if (receiverID != "None")
                    _missingReceiverStoreId = receiverID;
            }
            else
            {
                receiver = null;
            }

            receiverTargetJSON.choices = stringList;
            receiverTargetJSON.val = "None";
        }

        protected void SyncReceiverTarget(string receiverTargetName)
        {
            _receiverTargetName = receiverTargetName;
            receiverTarget = (JSONStorableVector3)null;
            if (receiver != null && receiverTargetName != null)
                receiverTarget = receiver.GetVector3JSONParam(receiverTargetName);
        }

        public UIDynamicTextField CreateTextInput(JSONStorableString jss, bool rightSide = false)
        {
            var textfield = CreateTextField(jss, rightSide);
            textfield.height = 1f;
            //textfield.backgroundColor = Color.white;
            var input = textfield.gameObject.AddComponent<InputField>();
            var rect = input.GetComponent<RectTransform>().sizeDelta = new Vector2(1f, 0.4f);
            input.textComponent = textfield.UItext;
            jss.inputField = input;
            return textfield;
        }

        public void SavePreset(string aPath)
        {
            if (System.String.IsNullOrEmpty(aPath))
            {
                return;
            }
            _lastBrowseDir = aPath.Substring(0, aPath.LastIndexOfAny(new char[] { '/', '\\' })) + @"\";

            if (!aPath.ToLower().EndsWith("WindControl".ToLower()))
            {
                aPath += "." + "WindControl";
            }
            JSONClass saveJson = new JSONClass();
            saveJson["savedBy"] = "WindControl";

            saveJson["rNippleFloat"] = this.GetFloatJSONParam("rNipple Mobility").val.ToString();
            saveJson["lNippleFloat"] = this.GetFloatJSONParam("lNipple Mobility").val.ToString();
            saveJson["pelvisFloat"] = this.GetFloatJSONParam("pelvis Mobility").val.ToString();
            saveJson["hipFloat"] = this.GetFloatJSONParam("hip Mobility").val.ToString();
            saveJson["rThighFloat"] = this.GetFloatJSONParam("rThigh Mobility").val.ToString();
            saveJson["lThighFloat"] = this.GetFloatJSONParam("lThigh Mobility").val.ToString();
            saveJson["rShinFloat"] = this.GetFloatJSONParam("rShin Mobility").val.ToString();
            saveJson["lShinFloat"] = this.GetFloatJSONParam("lShin Mobility").val.ToString();
            saveJson["rFootFloat"] = this.GetFloatJSONParam("rFoot Mobility").val.ToString();
            saveJson["lFootFloat"] = this.GetFloatJSONParam("lFoot Mobility").val.ToString();
            saveJson["LGluteFloat"] = this.GetFloatJSONParam("LGlute Mobility").val.ToString();
            saveJson["RGluteFloat"] = this.GetFloatJSONParam("RGlute Mobility").val.ToString();
            saveJson["abdomenFloat"] = this.GetFloatJSONParam("abdomen Mobility").val.ToString();
            saveJson["abdomen2Float"] = this.GetFloatJSONParam("abdomen2 Mobility").val.ToString();
            saveJson["chestFloat"] = this.GetFloatJSONParam("chest Mobility").val.ToString();
            saveJson["rCollarFloat"] = this.GetFloatJSONParam("rCollar Mobility").val.ToString();
            saveJson["lCollarFloat"] = this.GetFloatJSONParam("lCollar Mobility").val.ToString();
            saveJson["rShldrFloat"] = this.GetFloatJSONParam("rShldr Mobility").val.ToString();
            saveJson["lShldrFloat"] = this.GetFloatJSONParam("lShldr Mobility").val.ToString();
            saveJson["rForeArmFloat"] = this.GetFloatJSONParam("rForeArm Mobility").val.ToString();
            saveJson["lForeArmFloat"] = this.GetFloatJSONParam("lForeArm Mobility").val.ToString();
            saveJson["rHandFloat"] = this.GetFloatJSONParam("rHand Mobility").val.ToString();
            saveJson["lHandFloat"] = this.GetFloatJSONParam("lHand Mobility").val.ToString();
            saveJson["rPectoralFloat"] = this.GetFloatJSONParam("rPectoral Mobility").val.ToString();
            saveJson["lPectoralFloat"] = this.GetFloatJSONParam("lPectoral Mobility").val.ToString();
            saveJson["neckFloat"] = this.GetFloatJSONParam("neck Mobility").val.ToString();
            saveJson["headFloat"] = this.GetFloatJSONParam("head Mobility").val.ToString();

            saveJson["rNippleIsEnabled"] = this.GetBoolJSONParam("rNipple RigidBody").val.ToString();
            saveJson["lNippleIsEnabled"] = this.GetBoolJSONParam("lNipple RigidBody").val.ToString();
            saveJson["pelvisIsEnabled"] = this.GetBoolJSONParam("pelvis RigidBody").val.ToString();
            saveJson["hipIsEnabled"] = this.GetBoolJSONParam("hip RigidBody").val.ToString();
            saveJson["rThighIsEnabled"] = this.GetBoolJSONParam("rThigh RigidBody").val.ToString();
            saveJson["lThighIsEnabled"] = this.GetBoolJSONParam("lThigh RigidBody").val.ToString();
            saveJson["rShinIsEnabled"] = this.GetBoolJSONParam("rShin RigidBody").val.ToString();
            saveJson["lShinIsEnabled"] = this.GetBoolJSONParam("lShin RigidBody").val.ToString();
            saveJson["rFootIsEnabled"] = this.GetBoolJSONParam("rFoot RigidBody").val.ToString();
            saveJson["lFootIsEnabled"] = this.GetBoolJSONParam("lFoot RigidBody").val.ToString();
            saveJson["LGluteIsEnabled"] = this.GetBoolJSONParam("LGlute RigidBody").val.ToString();
            saveJson["RGluteIsEnabled"] = this.GetBoolJSONParam("RGlute RigidBody").val.ToString();
            saveJson["abdomenIsEnabled"] = this.GetBoolJSONParam("abdomen RigidBody").val.ToString();
            saveJson["abdomen2IsEnabled"] = this.GetBoolJSONParam("abdomen2 RigidBody").val.ToString();
            saveJson["chestIsEnabled"] = this.GetBoolJSONParam("chest RigidBody").val.ToString();
            saveJson["rCollarIsEnabled"] = this.GetBoolJSONParam("rCollar RigidBody").val.ToString();
            saveJson["lCollarIsEnabled"] = this.GetBoolJSONParam("lCollar RigidBody").val.ToString();
            saveJson["rShldrIsEnabled"] = this.GetBoolJSONParam("rShldr RigidBody").val.ToString();
            saveJson["lShldrIsEnabled"] = this.GetBoolJSONParam("lShldr RigidBody").val.ToString();
            saveJson["rForeArmIsEnabled"] = this.GetBoolJSONParam("rForeArm RigidBody").val.ToString();
            saveJson["lForeArmIsEnabled"] = this.GetBoolJSONParam("lForeArm RigidBody").val.ToString();
            saveJson["rHandIsEnabled"] = this.GetBoolJSONParam("rHand RigidBody").val.ToString();
            saveJson["lHandIsEnabled"] = this.GetBoolJSONParam("lHand RigidBody").val.ToString();
            saveJson["rPectoralIsEnabled"] = this.GetBoolJSONParam("rPectoral RigidBody").val.ToString();
            saveJson["lPectoralIsEnabled"] = this.GetBoolJSONParam("lPectoral RigidBody").val.ToString();
            saveJson["neckIsEnabled"] = this.GetBoolJSONParam("neck RigidBody").val.ToString();
            saveJson["headIsEnabled"] = this.GetBoolJSONParam("head RigidBody").val.ToString();

            this.SaveJSON(saveJson, aPath);
        }

        void LoadPreset(string aPath)
        {
            if (System.String.IsNullOrEmpty(aPath))
            {
                return;
            }
            _lastBrowseDir = aPath.Substring(0, aPath.LastIndexOfAny(new char[] { '/', '\\' })) + @"\";
            var aJson = this.LoadJSON(aPath);

            this.GetBoolJSONParam("rNipple RigidBody").val=aJson["rNippleIsEnabled"].AsBool;
            this.GetBoolJSONParam("lNipple RigidBody").val=aJson["lNippleIsEnabled"].AsBool;
            this.GetBoolJSONParam("pelvis RigidBody").val=aJson["pelvisIsEnabled"].AsBool;
            this.GetBoolJSONParam("hip RigidBody").val=aJson["hipIsEnabled"].AsBool;
            this.GetBoolJSONParam("rThigh RigidBody").val=aJson["rThighIsEnabled"].AsBool;
            this.GetBoolJSONParam("lThigh RigidBody").val=aJson["lThighIsEnabled"].AsBool;
            this.GetBoolJSONParam("rShin RigidBody").val=aJson["rShinIsEnabled"].AsBool;
            this.GetBoolJSONParam("lShin RigidBody").val=aJson["lShinIsEnabled"].AsBool;
            this.GetBoolJSONParam("rFoot RigidBody").val=aJson["rFootIsEnabled"].AsBool;
            this.GetBoolJSONParam("lFoot RigidBody").val=aJson["lFootIsEnabled"].AsBool;
            this.GetBoolJSONParam("LGlute RigidBody").val=aJson["LGluteIsEnabled"].AsBool;
            this.GetBoolJSONParam("RGlute RigidBody").val=aJson["RGluteIsEnabled"].AsBool;
            this.GetBoolJSONParam("abdomen RigidBody").val=aJson["abdomenIsEnabled"].AsBool;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=aJson["abdomen2IsEnabled"].AsBool;
            this.GetBoolJSONParam("chest RigidBody").val=aJson["chestIsEnabled"].AsBool;
            this.GetBoolJSONParam("rCollar RigidBody").val=aJson["rCollarIsEnabled"].AsBool;
            this.GetBoolJSONParam("lCollar RigidBody").val=aJson["lCollarIsEnabled"].AsBool;
            this.GetBoolJSONParam("rShldr RigidBody").val=aJson["rShldrIsEnabled"].AsBool;
            this.GetBoolJSONParam("lShldr RigidBody").val=aJson["lShldrIsEnabled"].AsBool;
            this.GetBoolJSONParam("rForeArm RigidBody").val=aJson["rForeArmIsEnabled"].AsBool;
            this.GetBoolJSONParam("lForeArm RigidBody").val=aJson["lForeArmIsEnabled"].AsBool;
            this.GetBoolJSONParam("rHand RigidBody").val=aJson["rHandIsEnabled"].AsBool;
            this.GetBoolJSONParam("lHand RigidBody").val=aJson["lHandIsEnabled"].AsBool;
            this.GetBoolJSONParam("rPectoral RigidBody").val=aJson["rPectoralIsEnabled"].AsBool;
            this.GetBoolJSONParam("lPectoral RigidBody").val=aJson["lPectoralIsEnabled"].AsBool;
            this.GetBoolJSONParam("neck RigidBody").val=aJson["neckIsEnabled"].AsBool;
            this.GetBoolJSONParam("head RigidBody").val=aJson["headIsEnabled"].AsBool;

            this.GetFloatJSONParam("rNipple Mobility").val=aJson["rNippleFloat"].AsFloat;
            this.GetFloatJSONParam("lNipple Mobility").val=aJson["lNippleFloat"].AsFloat;
            this.GetFloatJSONParam("pelvis Mobility").val=aJson["pelvisFloat"].AsFloat;
            this.GetFloatJSONParam("hip Mobility").val=aJson["hipFloat"].AsFloat;
            this.GetFloatJSONParam("rThigh Mobility").val=aJson["rThighFloat"].AsFloat;
            this.GetFloatJSONParam("lThigh Mobility").val=aJson["lThighFloat"].AsFloat;
            this.GetFloatJSONParam("rShin Mobility").val=aJson["rShinFloat"].AsFloat;
            this.GetFloatJSONParam("lShin Mobility").val=aJson["lShinFloat"].AsFloat;
            this.GetFloatJSONParam("rFoot Mobility").val=aJson["rFootFloat"].AsFloat;
            this.GetFloatJSONParam("lFoot Mobility").val=aJson["lFootFloat"].AsFloat;
            this.GetFloatJSONParam("LGlute Mobility").val=aJson["LGluteFloat"].AsFloat;
            this.GetFloatJSONParam("RGlute Mobility").val=aJson["RGluteFloat"].AsFloat;
            this.GetFloatJSONParam("abdomen Mobility").val=aJson["abdomenFloat"].AsFloat;
            this.GetFloatJSONParam("abdomen2 Mobility").val=aJson["abdomen2Float"].AsFloat;
            this.GetFloatJSONParam("chest Mobility").val=aJson["chestFloat"].AsFloat;
            this.GetFloatJSONParam("rCollar Mobility").val=aJson["rCollarFloat"].AsFloat;
            this.GetFloatJSONParam("lCollar Mobility").val=aJson["lCollarFloat"].AsFloat;
            this.GetFloatJSONParam("rShldr Mobility").val=aJson["rShldrFloat"].AsFloat;
            this.GetFloatJSONParam("lShldr Mobility").val=aJson["lShldrFloat"].AsFloat;
            this.GetFloatJSONParam("rForeArm Mobility").val=aJson["rForeArmFloat"].AsFloat;
            this.GetFloatJSONParam("lForeArm Mobility").val=aJson["lForeArmFloat"].AsFloat;
            this.GetFloatJSONParam("rHand Mobility").val=aJson["rHandFloat"].AsFloat;
            this.GetFloatJSONParam("lHand Mobility").val=aJson["lHandFloat"].AsFloat;
            this.GetFloatJSONParam("rPectoral Mobility").val=aJson["rPectoralFloat"].AsFloat;
            this.GetFloatJSONParam("lPectoral Mobility").val=aJson["lPectoralFloat"].AsFloat;
            this.GetFloatJSONParam("neck Mobility").val=aJson["neckFloat"].AsFloat;
            this.GetFloatJSONParam("head Mobility").val=aJson["headFloat"].AsFloat;
        }

        public override void Init()
        {
            try
            {
                initRBdicts();
                SetDefaultRBmobility();
                SetDefaultRBenabled();
                initializeAllLines();
                //debug_print_dictionary();

                if ((bool)(SuperController.singleton))
                    SuperController.singleton.onAtomUIDRenameHandlers += new SuperController.OnAtomUIDRename(OnAtomRename);

                
                isClothJSON = new JSONStorableBool("Affect Clothes", false, new JSONStorableBool.SetBoolCallback(SyncIsCloth));
                isHairJSON = new JSONStorableBool("Affect Hair", false, new JSONStorableBool.SetBoolCallback(SyncIsHair));
				isAvatarJSON = new JSONStorableBool("Affect Avatar", false, new JSONStorableBool.SetBoolCallback(SyncIsAvatar));
                pushAvatarJSON = new JSONStorableBool("Wind Pushes Avatar", false, new JSONStorableBool.SetBoolCallback(SyncPushAvatar));
                isTornadoJSON = new JSONStorableBool("Tornado Effect", false, new JSONStorableBool.SetBoolCallback(SyncIsTornado));
                isTornadoClockJSON = new JSONStorableBool("Tornado Wind Direction", false, new JSONStorableBool.SetBoolCallback(SyncIsTornadoClock));

                //receivingAtom stringChooser
                atomJSON = new JSONStorableStringChooser(
                  "atom", SuperController.singleton.GetAtomUIDs(), (string)null,
                  "Atom", new JSONStorableStringChooser.SetStringCallback(SyncAtom));

                atomJSON.popupOpenCallback = new JSONStorableStringChooser.PopupOpenCallback(SyncAtomChoices);
                receiverJSON = new JSONStorableStringChooser(
                  "receiver", (List<string>)null, (string)null,
                  "Receiver", new JSONStorableStringChooser.SetStringCallback(SyncReceiver));

                receiverTargetJSON = new JSONStorableStringChooser(
                  "receiverTarget", (List<string>)null, (string)null,
                  "Target", new JSONStorableStringChooser.SetStringCallback(SyncReceiverTarget));

                //receivingSlider StringChooser
                receivingSliderJSON = new JSONStorableStringChooser(
                  "slider", SuperController.singleton.GetAtomUIDs(), (string)null,
                  "Slider", new JSONStorableStringChooser.SetStringCallback(SyncAtom_slider));

                receivingSliderJSON.popupOpenCallback = new JSONStorableStringChooser.PopupOpenCallback(SyncAtomChoices_slider);
                slider_receiverJSON = new JSONStorableStringChooser(
                  "receivingSlider", (List<string>)null, (string)null,
                  "ReceivingSlider", new JSONStorableStringChooser.SetStringCallback(SyncReceiver_slider));

                sliderMagnitudeMatchJSON = new JSONStorableBool("Match Upper/Lower Magnitude", false, new JSONStorableBool.SetBoolCallback(SyncSliderMagnitudeMatch));
                topSliderMagnitudeJSON = new JSONStorableFloat("Top Slider Magnitude", 250f, 0f, 300f, false, true);
                bottomSliderMagnitudeJSON = new JSONStorableFloat("Bottom Slider Magnitude", -50f, -50f, 0f, false, true);
                currentMagnitudeJSON = new JSONStorableFloat("Current Magnitude (view)", 0.0f, -50f, 50f, false, true);
                randomWindSpeedJSON = new JSONStorableBool("Randomize Current Magnitude", false);
                oscillatingJSON = new JSONStorableBool("Oscillate Current Magnitude", false);
                periodRatioToggleJSON = new JSONStorableBool("Auto Period", false, new JSONStorableBool.SetBoolCallback(SyncPeriodRatioToggle));
                periodJSON = new JSONStorableFloat("Period Length", 0.03f, 0.0f, 1f, false, true);
                periodRatioJSON = new JSONStorableFloat("Period Coeff", 1f, 0f, 4f, false, true);
                quicknessJSON = new JSONStorableFloat("Quickness (view)", 30f, 0.0f, 240f, false, true);
                lowerMagnitudeJSON = new JSONStorableFloat("Lower Magnitude (view)", -50f, -50f, 200f, false, true);
                lowerMagnitudeRatioJSON = new JSONStorableFloat("Lower Magnitude Coeff", -0.25f, -1f, 1f, true, true);
                quicknessRatioToggleJSON = new JSONStorableBool("Auto Quickness", false, new JSONStorableBool.SetBoolCallback(SyncQuicknessRatioToggle));
                quicknessRatioJSON = new JSONStorableFloat("Quickness Coeff", 2f, 0f, 4f, false, true);
                upperMagnitudeJSON = new JSONStorableFloat("upperMagnitude", 150f, -50f, 150f, false, true);
                targetMagnitudeJSON = new JSONStorableFloat("targetMagnitude", 0.0f, -50f, 50f, false, false);
                directionDebugJSON = new JSONStorableBool("Turbulence debug", false, new JSONStorableBool.SetBoolCallback(SyncDirectionDebug));
                
                avatarMobility = new JSONStorableFloat("Avatar Mobility", 2f, 0.5f, 10f, true, true);
                windStrength = new JSONStorableFloat("Wind Strength", 0f, 0.0f, 250, false, true);
                windTurbulence = new JSONStorableFloat("Wind dir Turbulence", 0.5f, 0.0f, 1.0f, false, true);
                oscillationVariance = new JSONStorableFloat("Oscillation Variance", 1.5f, 1f, 100f, true, true);

                speedThreshold = new JSONStorableFloat("Velocity Threshold", 1f, 0.0f, 10f, false, true);
                speedMultiplier = new JSONStorableFloat("Velocity Multiplier", 10f, 0.0f, 10f, false, true);
                speedQuickness = new JSONStorableFloat("Interpolation rate", 10f, 0.0f, 10f, false, true);

                //customJSON = new JSONStorableFloat("Custom slider", 1f, 1f, 10000f, false, true);
                //xRotation = new JSONStorableFloat("Leaning Angle", containingAtom.GetStorableByID("control").transform.rotation.x,	(float newX)=>{setRotX(newX);}, -90f, 90, false, true);

                randomHairUndo_toggle_JSON = new JSONStorableBool("Hair Rigidity Control", false, new JSONStorableBool.SetBoolCallback((bool enabled)=>{
                    randomHairUndo_toggle=enabled;
                }));
                RegisterBool(randomHairUndo_toggle_JSON);
                randomHairUndo_threshold_JSON = new JSONStorableFloat("Hair Undo Threshold", 100f, 0.0f, 100f, false, true);
                RegisterFloat(randomHairUndo_threshold_JSON);
                randomHairUndoVal_JSON = new JSONStorableFloat("Hair Undo Stress (view)", 0f, 0f, 100f, false, true);
                RegisterFloat(randomHairUndoVal_JSON);
                randomHairUndoDecrement_JSON = new JSONStorableFloat("Hair Undo Relief", 0.4f, 0.0f, 1f, false, true);
                RegisterFloat(randomHairUndoDecrement_JSON);

                //RIGIDBODIES

                //Penis
                var penis_enab = new JSONStorableBool("Penis RigidBody", false,(bool enabled)=>
                {
                    penisControlEnabled=enabled;
                });
                RegisterBool(penis_enab);
                CreateToggle(penis_enab,true);
                penisControlMobility = new JSONStorableFloat("Penis Mobility", 20f, 0f, 50f, false, true);
                RegisterFloat(penisControlMobility);   
                CreateSlider(penisControlMobility,true);

                foreach(KeyValuePair<string,bool> RB_elem in RB_enabled)
                {
                    //Now you can access the key and value both separately from this attachStat as:
                    //SuperController.LogMessage("RB:"+RB_elem.Key+" val:"+RB_elem.Value+"");
                    var tempRB_enab = new JSONStorableBool(RB_elem.Key+" RigidBody", RB_elem.Value,(bool enabled)=>
                    {
                        RB_enabled[RB_elem.Key]=enabled;
                        
                        if(RB_elem.Key!="control")
                        {
                            if(enabled)
                            {
                                bodyLineDebug[RB_elem.Key].SetVertexCount(2);
                            }
                            else
                            {
                                bodyLineDebug[RB_elem.Key].SetVertexCount(0);
                            }
                        }
                        
                        //SuperController.LogMessage("updated RB:"+RB_elem.Key+" val:"+RB_enabled[RB_elem.Key]+"");
                    });
                    RegisterBool(tempRB_enab);
                    //SuperController.LogMessage("RB:"+tempRB_enab.val+" val:"+RB_elem.Value+"");
                    CreateToggle(tempRB_enab,true);
                    //var temp_mobility=RB_mobility[RB_elem.Key].val;
                    RB_mobility[RB_elem.Key] = new JSONStorableFloat(RB_elem.Key+" Mobility", 0.25f, 0.1f, 1.0f, false, true);
                    RegisterFloat(RB_mobility[RB_elem.Key]);   
                    CreateSlider(RB_mobility[RB_elem.Key],true);
                }
                RBpreset_enableMain();
                RegisterStringChooser(atomJSON);
                CreateScrollablePopup(atomJSON, false);
                RegisterStringChooser(receivingSliderJSON);
                CreateScrollablePopup(receivingSliderJSON, false);

                isRadialJSON = new JSONStorableBool("Radial Wind", false, (bool b)=>{SyncIsRadial(b); });
                isRadialIntensityJSON = new JSONStorableBool("Radial Wind Decay", false, (bool b)=>{SyncIsRadialIntensity(b); });
                isBlowingJSON = new JSONStorableBool("Suck/Blow", false, new JSONStorableBool.SetBoolCallback(SyncIsBlowing));
                isBySpeedJSON = new JSONStorableBool("Velocity = Wind Stength", false, new JSONStorableBool.SetBoolCallback(SyncIsBySpeed));
                isByRotationJSON = new JSONStorableBool("Speed/Rotation", false, new JSONStorableBool.SetBoolCallback(SyncIsByRotation));
                windDecay = new JSONStorableFloat("Wind Decay", 1f, 0f, 2f, false, true);
                


				RegisterBool(isAvatarJSON);
                RegisterBool(pushAvatarJSON);
                RegisterBool(isHairJSON);
                RegisterBool(isClothJSON);
                RegisterBool(randomWindSpeedJSON);
                RegisterBool(sliderMagnitudeMatchJSON);
                RegisterBool(oscillatingJSON);
                RegisterFloat(periodJSON);
                //RegisterFloat(periodRatioJSON);
                RegisterBool(quicknessRatioToggleJSON);
                RegisterBool(periodRatioToggleJSON);
                RegisterFloat(quicknessJSON);
                RegisterFloat(upperMagnitudeJSON);
                RegisterFloat(lowerMagnitudeJSON);
                RegisterFloat(lowerMagnitudeRatioJSON);
                RegisterFloat(quicknessRatioJSON);
                RegisterFloat(topSliderMagnitudeJSON);
                RegisterFloat(bottomSliderMagnitudeJSON);
                RegisterFloat(currentMagnitudeJSON);
                RegisterFloat(windStrength);
                RegisterFloat(windTurbulence);
                RegisterBool(directionDebugJSON);
                RegisterFloat(avatarMobility);
                RegisterFloat(oscillationVariance);
                //RegisterFloat(xRotation);

                CreateToggle(sliderMagnitudeMatchJSON);
                CreateSlider(topSliderMagnitudeJSON);
                CreateSlider(bottomSliderMagnitudeJSON);
                CreateToggle(isAvatarJSON);
                CreateToggle(isClothJSON);
                CreateToggle(isHairJSON);
                CreateToggle(randomWindSpeedJSON);
                CreateToggle(oscillatingJSON);
                CreateToggle(pushAvatarJSON);
                CreateSlider(windStrength);
                CreateSlider(currentMagnitudeJSON);
                 
                CreateSlider(lowerMagnitudeRatioJSON);
                CreateSlider(lowerMagnitudeJSON);
                CreateToggle(quicknessRatioToggleJSON);
                CreateSlider(quicknessRatioJSON);
                CreateSlider(quicknessJSON);
                //CreateSlider(periodRatioJSON);
                CreateToggle(periodRatioToggleJSON);
                CreateSlider(periodJSON);
                CreateSlider(oscillationVariance);
                
                CreateSlider(windTurbulence);
                //CreateToggle(directionDebugJSON);
                CreateSlider(avatarMobility);

                //RegisterFloat(customJSON);
                //CreateSlider(customJSON);
                //CreateSlider(xRotation);

                var tmpToggle = CreateToggle(randomHairUndo_toggle_JSON);
                color_toggle(tmpToggle,Color.black,Color.cyan);
                var tmpSlider = CreateSlider(randomHairUndo_threshold_JSON);
                color_slider(tmpSlider,Color.black,Color.cyan);
                tmpSlider = CreateSlider(randomHairUndoVal_JSON);
                color_slider(tmpSlider,Color.black,Color.cyan);
                tmpSlider = CreateSlider(randomHairUndoDecrement_JSON);
                color_slider(tmpSlider,Color.black,Color.cyan);
                setAllHair("Disable Hair Rigidity", false, false);
			    setAllHair("Enable Hair Rigidity", true, false);

                RegisterBool(isRadialJSON);
                tmpToggle = CreateToggle(isRadialJSON);
                color_toggle(tmpToggle,Color.white,Color.grey);              

                tmpToggle = CreateToggle(isBlowingJSON);
                color_toggle(tmpToggle,Color.white,Color.grey);
                RegisterBool(isBlowingJSON);

                tmpToggle = CreateToggle(isTornadoJSON);
                color_toggle(tmpToggle,Color.white,Color.grey);
                RegisterBool(isTornadoJSON);

                tmpToggle = CreateToggle(isTornadoClockJSON);
                color_toggle(tmpToggle,Color.white,Color.grey);
                RegisterBool(isTornadoClockJSON);

                tmpToggle = CreateToggle(isRadialIntensityJSON);
                color_toggle(tmpToggle,Color.white,Color.grey);
                RegisterBool(isRadialIntensityJSON);

                tmpSlider = CreateSlider(windDecay);
                color_slider(tmpSlider, Color.white, Color.grey);
                RegisterFloat(windDecay);

                tmpToggle = CreateToggle(isBySpeedJSON);
                color_toggle(tmpToggle,Color.black,Color.yellow);
                RegisterBool(isBySpeedJSON);
                tmpToggle = CreateToggle(isByRotationJSON);
                color_toggle(tmpToggle,Color.black,Color.yellow);
                RegisterBool(isByRotationJSON);
                RegisterFloat(speedThreshold);
                tmpSlider = CreateSlider(speedThreshold);
                color_slider(tmpSlider,Color.black, Color.yellow);
                RegisterFloat(speedMultiplier);
                tmpSlider = CreateSlider(speedMultiplier);
                color_slider(tmpSlider,Color.black, Color.yellow);
                RegisterFloat(speedQuickness);
                tmpSlider = CreateSlider(speedQuickness);
                color_slider(tmpSlider,Color.black, Color.yellow);

                //CreateTextInput(new JSONStorableString("info","COLLIDERS PRESETS"), false);
                var enable_main_btn = CreateButton("Enable Main Colliders", false);
                color_btn(enable_main_btn,Color.black,Color.green);
                enable_main_btn.button.onClick.AddListener(RBpreset_enableMain);
                JSONStorableAction enable_main_colliders_action = new JSONStorableAction("Enable Main Colliders", () => {RBpreset_enableMain();});
                RegisterAction(enable_main_colliders_action);

                var disable_all_btn = CreateButton("Disable all Colliders", false);
                color_btn(disable_all_btn,Color.black,Color.green);
                disable_all_btn.button.onClick.AddListener(RBpreset_disableAll);
                JSONStorableAction disable_all_colliders_action = new JSONStorableAction("Disable All Colliders", () => {RBpreset_disableAll();});
                RegisterAction(disable_all_colliders_action);

                var enable_all_btn = CreateButton("Enable all Colliders", false);
                color_btn(enable_all_btn,Color.black,Color.green);
                enable_all_btn.button.onClick.AddListener(RBpreset_enableAll);
                JSONStorableAction enable_all_colliders_action = new JSONStorableAction("Enable All Colliders", () => {RBpreset_enableAll();});
                RegisterAction(enable_all_colliders_action);

                var enable_all_btn_noHands = CreateButton("Enab all except hands", false);
                color_btn(enable_all_btn_noHands,Color.black,Color.green);
                enable_all_btn_noHands.button.onClick.AddListener(RBpreset_enableAll_noHands);
                JSONStorableAction enable_all_colliders_action_noHands = new JSONStorableAction("Enable All Colliders without Hands", () => {RBpreset_enableAll_noHands();});
                RegisterAction(enable_all_colliders_action_noHands);

                var enable_all_btn_noFeet = CreateButton("Enab all except feet", false);
                color_btn(enable_all_btn_noFeet,Color.black,Color.green);
                enable_all_btn_noFeet.button.onClick.AddListener(RBpreset_enableAll_noFeet);
                JSONStorableAction enable_all_colliders_action_noFeet = new JSONStorableAction("Enable All Colliders without Feet", () => {RBpreset_enableAll_noFeet();});
                RegisterAction(enable_all_colliders_action_noFeet);

                var enable_all_btn_noHandsFeet = CreateButton("Enab all except hands/feet", false);
                color_btn(enable_all_btn_noHandsFeet,Color.black,Color.green);
                enable_all_btn_noHandsFeet.button.onClick.AddListener(RBpreset_enableAll_noHandsFeet);
                JSONStorableAction enable_all_colliders_action_noHandsFeet = new JSONStorableAction("Enable All Colliders without Hands and Feet", () => {RBpreset_enableAll_noHandsFeet();});
                RegisterAction(enable_all_colliders_action_noHandsFeet);

                var reset_all_float_btn = CreateButton("Reset all Colliders Values", false);
                color_btn(reset_all_float_btn,Color.black,Color.green);
                reset_all_float_btn.button.onClick.AddListener(RBpreset_floatVal);
                JSONStorableAction reset_all_colliders_float_action = new JSONStorableAction("Reset All Colliders Values", () => {RBpreset_floatVal();});
                RegisterAction(reset_all_colliders_float_action);

                btn = CreateButton("Save Colliders Preset");
                color_btn(btn,Color.white,Color.blue);
                btn.button.onClick.AddListener(() =>
                {
                    SuperController.singleton.NormalizeMediaPath(_lastBrowseDir);
                    SuperController.singleton.GetMediaPathDialog(SavePreset, "WindControl");

                uFileBrowser.FileBrowser browser = SuperController.singleton.mediaFileBrowserUI;
                    browser.SetTextEntry(true);
                    browser.fileEntryField.text = System.String.Format("{0}.{1}", ((int)(System.DateTime.UtcNow - new System.DateTime(1970, 1, 1)).TotalSeconds).ToString(), "WindControl");
                    browser.ActivateFileNameField();
                });

                btn = CreateButton("Load Colliders Preset");
                color_btn(btn,Color.white,Color.blue);
                btn.button.onClick.AddListener(() =>
                {
                    SuperController.singleton.NormalizeMediaPath(_lastBrowseDir);
                    SuperController.singleton.GetMediaPathDialog(LoadPreset, "WindControl");
                });
            }
            catch (System.Exception e)
            {
                SuperController.LogError("" + e);
            }
        }

        protected void OnDisable() //Disable Wind on clothes when the plugin is disabled
        {
            turnWindOff_Clothes();
            turnWindOff_Hair();
        }

        protected void OnEnable() //Disable Wind on clothes when the plugin is disabled
        {
            turnWindOff_Clothes();
            turnWindOff_Hair();
        }

        protected void FixedUpdate()
        {
            
 
        }

        protected void Update ()
        {
            try
            {
                if(receivingAtom!=null && receivingAtom.type=="Person")
                {
                    var targetDirection = new Vector3();
                    var oldDirection = newDirection;
                    //Setting up parameters
                    lowerMagnitudeJSON.val=windStrength.val*lowerMagnitudeRatioJSON.val;
                    upperMagnitudeJSON.val=windStrength.val;
                    quicknessJSON.val=0.1f+quicknessRatioJSON.val*windStrength.val/5;
                    if(quicknessRatioToggle)
                    {
                        //quicknessJSON.val=windStrength.val/5;
                        quicknessJSON.val=0.04f*windStrength.val + 10;
                    }
                    if(periodRatioToggle)
                    {
                        //periodJSON.val=0.2f-(windStrength.val/1000);
                        periodJSON.val=-0.00032f*windStrength.val + 0.1f;
                    }
                    var WindController=containingAtom.GetStorableByID("control").transform;

                    //Set Wind Direction
                    var personDirection=receivingAtom.GetStorableByID("chestControl").transform.position - (new Vector3(WindController.position.x, WindController.position.y, WindController.position.z));
                    if(isRadial)
                    {
                        if(isBlowing)
                        {
                            targetDirection=personDirection;
                        }
                        else
                        {
                            targetDirection=-personDirection;
                        }
                    }
                    else if(isTornado)
                    {
                        var tornadoDistance=personDirection.magnitude*personDirection.magnitude/100;
                        var distanceValue=Mathf.Lerp(2f,-2f,tornadoDistance*windDecay.val*2);
                        if(isTornadoClock)
                        {
                            targetDirection=new Vector3(personDirection.z, -personDirection.y,-personDirection.x+distanceValue);
                        }
                        else
                        {
                            targetDirection=new Vector3(-personDirection.z, -personDirection.y,personDirection.x+distanceValue);
                        }
                    }
                    else
                    {
                        targetDirection=WindController.transform.forward;
                    }

                    //Set wind Speed
                    if(isBySpeed||isByRotation)
                    {
                        strengthByVelocity();
                    }

                    timer -= Time.deltaTime;
                    
                    if ((double)timer < 0.0)
                    {
                        timer = periodJSON.val + Random.Range(-periodJSON.val,periodJSON.val)/10;
                        setWindTurbulence();
                        //newTargetDirection = new Vector3(targetDirection.x + windRandomX, targetDirection.y + windRandomY, targetDirection.z+windRandomZ);
                        newTargetDirection = Quaternion.Euler(windRandomX, windRandomY, windRandomZ) * targetDirection;
                        
                        if (randomWindSpeedJSON != null && randomWindSpeedJSON.val)
                        {
                            if(oscillatingJSON.val)
                            {
                                if(oscillationVariance.val<1)
                                {
                                    oscillationVariance.val=1;
                                }
                                var oscillation_random_temp=Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val)/oscillationVariance.val;
                                if(oscillation)
                                {
                                    
                                    targetMagnitudeJSON.val=upperMagnitudeJSON.val-oscillation_random_temp;
                                    oscillation=false;
                                }
                                else
                                {
                                    targetMagnitudeJSON.val=lowerMagnitudeJSON.val+oscillation_random_temp;
                                    oscillation=true;
                                }
                            }
                            else
                            {
                                targetMagnitudeJSON.val = Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val);
                            }
                        }
                    }
                    if (randomWindSpeedJSON != null && randomWindSpeedJSON.val)
                    {
                        currentMagnitudeJSON.val = Mathf.Lerp(currentMagnitudeJSON.val, targetMagnitudeJSON.val, Time.deltaTime * quicknessJSON.val);
                    }
                    else
                    {
                        currentMagnitudeJSON.val = windStrength.val;
                    }

                    if(windStrength.val<0.1f)
                    {
                        currentMagnitudeJSON.val=0;
                    }

                    newDirection = Vector3.Lerp(newDirection, newTargetDirection, Time.deltaTime * quicknessJSON.val);
                    if(directionDebugJSON.val){drawVector(newDirection*currentMagnitudeJSON.val/200);}

                    //Wind Decay by distance
                    if(isRadialIntensity)
                    {
                        var distanceFactor=personDirection.magnitude;
                        var decayFactor=distanceFactor*windDecay.val;

                        if(decayFactor<1)
                        {
                            decayFactor=1;
                        }
                        currentMagnitudeJSON.val=currentMagnitudeJSON.val/decayFactor;
                        

                        if(currentMagnitudeJSON.val < 1 && currentMagnitudeJSON.val > -1)
                        {
                            currentMagnitudeJSON.val=0;
                        }
                    }

                    //Apply wind to clothes
                    if (isHair||isCloth)
                    {
                        foreach (string storableId in receivingAtom.GetStorableIDs())
                        {
                            if((checkBoolJSONParam(storableId, "simEnabled"))||(checkBoolJSONParam(storableId, "simulationEnabled")))
                            {
                                SyncReceiver(storableId);
                                if(hairCheck(storableId)&&isHair)
                                {
                                    foreach (string vector3ParamName in receiver.GetVector3ParamNames())
                                    {
                                        updateClothHair(vector3ParamName);
                                    }
                                }
                                else if(!hairCheck(storableId)&&isCloth)
                                {
                                    foreach (string vector3ParamName in receiver.GetVector3ParamNames())
                                    {
                                        updateClothHair(vector3ParamName);
                                    }
                                }

                                
                            }
                        }
                        
                    }

                    

                    //Apply wind to rigidbodies
                    if (isAvatar)
                    {
                        foreach(KeyValuePair<string,bool> RB_elem in RB_enabled)
                        {
                            if(RB_elem.Value)
                            {
                                //Add Wind direction turbulence
                                //setWindTurbulence();

                                if(RB_elem.Key=="control")
                                {
                                    updateController_control(RB_mobility[RB_elem.Key]);
                                }
                                else
                                {
                                    updateController(RB_elem.Key, RB_mobility[RB_elem.Key]);
                                }
                            }
                        }
                        updateController_controller("penisTipControl",mobility_penis);
                    }

                    //debug_print_dictionary();
                    //Random Hair Undo
                    if(randomHairUndo_toggle)
                    {
                        randomHairUndoVal_JSON.val += currentMagnitudeJSON.val/100 - randomHairUndoDecrement_JSON.val;
                        if(randomHairUndoVal_JSON.val<0)
                        {
                            randomHairUndoVal_JSON.val=0;
                        }
                        if(randomHairUndoVal_JSON.val>1000)
                        {
                            randomHairUndoVal_JSON.val=1000;
                        }
                        if(randomHairUndoVal_JSON.val > randomHairUndo_threshold_JSON.val)
                        {
                            updateAllHair(false);
                        }
                    }

                    //Sending currentmagnitude to selected slider
                    if(receivingSlider != null)
                    {
                        if(sliderMagnitudeMatch)
                        {
                            bottomSliderMagnitudeJSON.val=lowerMagnitudeJSON.val;
                            topSliderMagnitudeJSON.val=upperMagnitudeJSON.val;
                        }
                        if(bottomSliderMagnitudeJSON.val >= topSliderMagnitudeJSON.val)
                        {
                            bottomSliderMagnitudeJSON.val = topSliderMagnitudeJSON.val-0.01f;
                        }
                        receivingSlider.GetStorableByID("Trigger").GetFloatJSONParam("value").val=(currentMagnitudeJSON.val - bottomSliderMagnitudeJSON.val)/(topSliderMagnitudeJSON.val - bottomSliderMagnitudeJSON.val);
                    }
                }
            }
            
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
        }

        protected void strengthByVelocity()
        {
            foreach (ForceReceiver fr in containingAtom.forceReceivers)
            {
                if(fr.name=="object")
                {
                    if(timer2<1)
                    {
                        timer2+=Time.deltaTime * speedQuickness.val;
                        windStrength.val=Mathf.Lerp(oldSpeed, speed, timer2);
                    }
                    else
                    {
                        var RBvelocity=0f;
                        var RBvelocityLin=0f;
                        var RBvelocityAng=0f;
                        oldSpeed=speed;
                        var RB = fr.GetComponent<Rigidbody>();
                        if(isByRotation)
                        {
                            RBvelocityAng=RB.angularVelocity.magnitude;
                        }
                        if(isBySpeed)
                        {
                            RBvelocityLin=RB.velocity.magnitude;
                        }
                        RBvelocity=RBvelocityLin+RBvelocityAng;
                        speed=(RBvelocity-speedThreshold.val)*speedMultiplier.val;
                        if(speed<0){speed=0;}
                        timer2=0f;
                    }
                }
            }
            
        }

        protected void updateController_control(JSONStorableFloat mobility)
        {
            //var frWindDirection=new Vector3(newDirection.x + windRandomX,0, newDirection.z + windRandomZ);
            var mobilityFactor=mobility.val*avatarMobility.val*100000;
            var forceValue=currentMagnitudeJSON.val;
            var newControlDirection = new Vector3(newDirection.x,0,newDirection.z);

            if(currentMagnitudeJSON.val==0)
            {
                receivingAtom.GetStorableByID("control").transform.position+=currentMagnitudeJSON.val * newControlDirection;
            }
            else
            {
                receivingAtom.GetStorableByID("control").transform.position+=(forceValue / mobilityFactor) * (newControlDirection);
            }
        }

        protected void updateClothHair(string vector3ParamName)
        {
            SyncReceiverTarget(vector3ParamName);
            var subRandomPush=Random.Range(-currentMagnitudeJSON.val/8, currentMagnitudeJSON.val/2);
            if(!timers.ContainsKey(vector3ParamName))
            {
                timers[vector3ParamName]=0;
            }
            timers[vector3ParamName] -= Time.deltaTime;
            if ((double)timers[vector3ParamName] < 0.0)
            {
                timers[vector3ParamName] = periodJSON.val + Random.Range(-periodJSON.val,periodJSON.val)/5;

                var RandomY=Random.Range(-windTurbulence.val, windTurbulence.val)*40;
                var RandomX=Random.Range(-windTurbulence.val, windTurbulence.val)*40;
                var RandomZ=Random.Range(-windTurbulence.val, windTurbulence.val)*40;

                if(!newWindDirections.ContainsKey(vector3ParamName))
                {
                    newWindDirections[vector3ParamName]=new Vector3();
                }
                newWindDirections[vector3ParamName] = Quaternion.Euler(RandomX, RandomY, RandomZ) * newDirection;
            }
            if(!controllerWindForce.ContainsKey(vector3ParamName))
            {
                controllerWindForce[vector3ParamName]=new Vector3();
            }
            controllerWindForce[vector3ParamName] = Vector3.Lerp(controllerWindForce[vector3ParamName], newWindDirections[vector3ParamName], Time.deltaTime * quicknessJSON.val);
            //controllerWindForce[vector3ParamName] *= ((currentMagnitudeJSON.val + subRandomPush)/400);
            //var clothWindDirection=new Vector3(newDirection.x + windRandomX, newDirection.y + windRandomY, newDirection.z);
            //var cloth_obj = receivingAtom.GetStorableByID(vector3ParamName) as ClothSimControl;
            if(currentMagnitudeJSON.val!=0)
            {
                receiverTarget.val = (currentMagnitudeJSON.val + subRandomPush) * controllerWindForce[vector3ParamName].normalized;
            }
            else
            {
                receiverTarget.val = (currentMagnitudeJSON.val) * controllerWindForce[vector3ParamName].normalized;
            }
        }

        protected void updateController(string Controller, JSONStorableFloat mobility)
        {
            try
            {
                SyncReceiverRB(Controller);
                var temp_controller = new FreeControllerV3();
                //var new_WindDirection = new Vector3();
                if(!receivingAtom.GetStorableByID(Controller+"Control"))
                {}
                else if(pushAvatar)
                {
                    temp_controller = receivingAtom.GetStorableByID(Controller+"Control") as FreeControllerV3;
                }
                var subRandomPush=Random.Range(-currentMagnitudeJSON.val/8, currentMagnitudeJSON.val/2);
                
                if(!timers.ContainsKey(Controller))
                {
                    timers[Controller]=0;
                }
                timers[Controller] -= Time.deltaTime;
                if ((double)timers[Controller] < 0.0)
                {
                    timers[Controller] = periodJSON.val + Random.Range(-periodJSON.val,periodJSON.val)/5;

                    var RandomY=Random.Range(-windTurbulence.val, windTurbulence.val)*40;
                    var RandomX=Random.Range(-windTurbulence.val, windTurbulence.val)*40;
                    var RandomZ=Random.Range(-windTurbulence.val, windTurbulence.val)*40;

                    if(!newWindDirections.ContainsKey(Controller))
                    {
                        newWindDirections[Controller]=new Vector3();
                    }
                    newWindDirections[Controller] = Quaternion.Euler(RandomX, RandomY, RandomZ) * newDirection;
                }      

                if(!controllerWindForce.ContainsKey(Controller))
                {
                    controllerWindForce[Controller]=new Vector3();
                }
                controllerWindForce[Controller] = Vector3.Lerp(controllerWindForce[Controller], newWindDirections[Controller], Time.deltaTime * quicknessJSON.val);
                
                var mobilityFactor=mobility.val*avatarMobility.val*10;
                var mobilityFactorController=mobility.val*avatarMobility.val*100000;
                var forceValue=currentMagnitudeJSON.val+subRandomPush/400;
                //RB.drag = customJSON.val;

                //Draw debug wind direction
                if(directionDebug && Controller!="control")
                {
                    drawBodyVector((forceValue /(50*mobilityFactor)) * (controllerWindForce[Controller].normalized), bodyLineDebug[Controller]);
                }
                
                

                if(mobilityFactor<1)
                {
                    mobilityFactor=1;
                }
                if(currentMagnitudeJSON.val==0)
                {
                    RB.AddForce(currentMagnitudeJSON.val * controllerWindForce[Controller]);
                    if(!receivingAtom.GetStorableByID(Controller+"Control"))
                    {}
                    else if(pushAvatar)
                    {
                        temp_controller.transform.position += currentMagnitudeJSON.val * controllerWindForce[Controller];
                    }
                    
                }
                else
                {
                    RB.AddForce((forceValue / mobilityFactor) * (controllerWindForce[Controller].normalized), ForceMode.Acceleration);
                    if(!receivingAtom.GetStorableByID(Controller+"Control"))
                    {}
                    else if(pushAvatar)
                    {
                        temp_controller.transform.position += (forceValue / mobilityFactorController) * (controllerWindForce[Controller]);
                    }
                }
            }
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
        }

        protected void updateController_controller(string Controller, JSONStorableFloat mobility)
        {
            try
            {
                var temp_controller = new FreeControllerV3();
                if(!receivingAtom.GetStorableByID(Controller))
                {}
                else
                {
                    temp_controller = receivingAtom.GetStorableByID(Controller) as FreeControllerV3;
                }    
                var subRandomPush=Random.Range(-currentMagnitudeJSON.val/8, currentMagnitudeJSON.val/4);
                var RandomY=Random.Range(0, 0.2f);
                var RandomX=Random.Range(-windTurbulence.val, windTurbulence.val);
                var RandomZ=Random.Range(-windTurbulence.val, windTurbulence.val);
                var frWindDirection=new Vector3(newDirection.x + RandomX, newDirection.y + RandomY, newDirection.z + RandomZ);
                var mobilityFactor=mobility.val*avatarMobility.val*10;
                var mobilityFactorController=mobility.val*avatarMobility.val*100000;
                var forceValue=currentMagnitudeJSON.val+RandomPush;
                var complySpring=currentMagnitudeJSON.val;
                if(complySpring<0)
                {
                    complySpring=0;
                }

                if(mobilityFactor<1)
                {
                    mobilityFactor=1;
                }
                if(currentMagnitudeJSON.val==0)
                {
                    if(!receivingAtom.GetStorableByID(Controller))
                    {}
                    else
                    {
                        temp_controller.transform.position += currentMagnitudeJSON.val * frWindDirection.normalized;
                    }
                    
                }
                else
                {
                    if(!receivingAtom.GetStorableByID(Controller))
                    {}
                    else
                    {
                        temp_controller.transform.position += (forceValue / mobilityFactorController) * (frWindDirection.normalized);
                        if(penisControlEnabled)
                        {
                            receivingAtom.GetStorableByID(Controller).GetFloatJSONParam("complyPositionSpring").val=complySpring*penisControlMobility.val;
                        }
                        
                    }
                }
            }
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
        }

        protected void turnWindOff_Clothes()
        {
            try
            {
                if(receivingAtom != null)
                {
                    foreach (string storableId in receivingAtom.GetStorableIDs())
                    {
                        SyncReceiver(storableId);

                        if(!hairCheck(storableId))
                        {
                            foreach (string vector3ParamName in receiver.GetVector3ParamNames())
                            {
                                SyncReceiverTarget(vector3ParamName);
                                var clothWindDirection = new Vector3(0,-9.8f,0);
                                receiverTarget.val = clothWindDirection;
                            }
                        }
                    }
                }

            }
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
        }

        protected void turnWindOff_Hair()
        {
            try
            {
                if(receivingAtom != null)
                {
                    foreach (string storableId in receivingAtom.GetStorableIDs())
                    {
                        SyncReceiver(storableId);

                        if(hairCheck(storableId))
                        {
                            foreach (string vector3ParamName in receiver.GetVector3ParamNames())
                            {
                                SyncReceiverTarget(vector3ParamName);
                                var clothWindDirection = new Vector3(0,-9.8f,0);
                                receiverTarget.val = clothWindDirection;
                            }
                        }
                        
                    }
                }

            }
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
        }
        

        //Functions to Undo and Redo hair
        void setAllHair(string text, bool value, bool right)
        {
            var temp_btn = CreateButton(text, right);
            color_btn(temp_btn,Color.black,Color.cyan);
            temp_btn.button.onClick.AddListener(() => {
                randomHairUndoVal_JSON.val = 0;
                updateAllHair(value);
            });
            JSONStorableAction tmp_action = new JSONStorableAction(text, () => {
                randomHairUndoVal_JSON.val = 0;
                updateAllHair(value);
            });
            RegisterAction(tmp_action);
            
		}

        void updateAllHair(bool value)
        {
            foreach(string storableId in receivingAtom.GetStorableIDs())
            {
                if(storableId.Contains("Sim"))
                {
                    var hairProp=receivingAtom.GetStorableByID(storableId);
                    {
                        if(hairProp!=null && hairProp.GetBoolJSONParam("usePaintedRigidity")!=null)
                        {
                            hairProp.GetBoolJSONParam("usePaintedRigidity").val=value;
                        }
                        
                    }
                    
                }
            }
        }

        //Functions to color UI elements
        protected void color_slider(UIDynamicSlider slider, Color text,Color background)
        {
            var sliderBGImage = slider.GetComponentInChildren<Image>();
            sliderBGImage.color = background;
            slider.labelText.color=text;
        }

        protected void color_toggle(UIDynamicToggle toggle, Color text,Color background)
        {
            toggle.backgroundColor=background;
            toggle.textColor=text;
        }

        protected void color_btn(UIDynamicButton btn, Color text,Color background)
        {
            btn.buttonColor = background;
            btn.textColor = text;
        }

        protected void setControllerStateOff(string controller)
        {
            FreeControllerV3 headControl = receivingAtom.GetStorableByID(controller) as FreeControllerV3;
            headControl.currentPositionState=FreeControllerV3.PositionState.Off;
            headControl.currentRotationState=FreeControllerV3.RotationState.Off;
        }

        protected void setControllerStateComply(string controller)
        {
            FreeControllerV3 headControl = receivingAtom.GetStorableByID(controller) as FreeControllerV3;
            headControl.currentPositionState=FreeControllerV3.PositionState.Comply;
            headControl.currentRotationState=FreeControllerV3.RotationState.Comply;
        }

        protected void setWindTurbulence()
        {
            RandomPush=Random.Range(-currentMagnitudeJSON.val/8, currentMagnitudeJSON.val/4);
            windRandomY=Random.Range(-windTurbulence.val, windTurbulence.val)*20;
            windRandomX=Random.Range(-windTurbulence.val, windTurbulence.val)*20;
            windRandomZ=Random.Range(-windTurbulence.val, windTurbulence.val)*20;
        }

        protected bool checkBoolJSONParam(string storableId, string boolJSONParam)
        {
            if(receivingAtom.GetStorableByID(storableId).GetBoolJSONParam(boolJSONParam)!=null)
            {
                if(receivingAtom.GetStorableByID(storableId).GetBoolJSONParam(boolJSONParam).val)
                {
                    return true;
                }
            }
            return false;
        }

        protected bool hairCheck(string storableId)
        {
            return receivingAtom.GetStorableByID(storableId).GetBoolJSONParam("usePaintedRigidity")!=null;
        }

        //Turbulence debug options
        public void drawVector(Vector3 v3)
        {
            var WindController = containingAtom.GetStorableByID("control").transform.position;
            _linePoints[0] = WindController;
            _linePoints[1] = WindController + v3;
            _lineRenderer.SetPositions(_linePoints);
            //SetLineColor(_linePoints, Color.green : Color.gray);
        }

        public void initLineRenderer()
        {
            var lockLineGo = new GameObject("Wind_direction");
            _lineRenderer = lockLineGo.AddComponent<LineRenderer>();
            _lineRenderer.useWorldSpace = true;
            _lineRenderer.material = new Material(Shader.Find("Sprites/Default")) {renderQueue = 4000};
            SetLineColor(_lineRenderer, Color.green);
            _lineRenderer.startWidth = 0.1f;
            _lineRenderer.endWidth = 0.001f;
            _lineRenderer.positionCount = 2;
            _linePoints = new Vector3[2];
        }

        public void drawBodyVector(Vector3 direction, LineRenderer _lineRenderer)
        {
            var bodyPart = RB.transform.position;
            var points = new Vector3[2];
            points[0] = bodyPart;
            points[1] = bodyPart + direction;
            _lineRenderer.SetPositions(points);
            _lineRenderer.startWidth = 0.1f*direction.magnitude;
        }

        public LineRenderer initBodyLineRender(LineRenderer _lineRenderer)
        {
            _lineRenderer.useWorldSpace = true;
            _lineRenderer.material = new Material(Shader.Find("Sprites/Default")) {renderQueue = 4000};
            SetLineColor(_lineRenderer, Color.green);
            _lineRenderer.startWidth = 0.1f;
            _lineRenderer.endWidth = 0.001f;
            _lineRenderer.positionCount = 2;
            return _lineRenderer;
        }
        
        private static void SetLineColor(LineRenderer lineRenderer, Color color)
        {
            lineRenderer.colorGradient = new Gradient
            {
                colorKeys = new[] {new GradientColorKey(color, 0f), new GradientColorKey(color, 1f)}
            };
        }

        public void destroyAllLines()
        {
            foreach(KeyValuePair<string,LineRenderer> elem in bodyLineDebug){
                //Destroy(elem.Value);
                Destroy(bodyLineDebug[elem.Key]);
            }
        }

        public void initializeAllLines()
        {
            try{
                foreach(KeyValuePair<string,bool> RB in RB_enabled)
                {
                    if(RB.Key!="control")
                    {
                        //SuperController.LogMessage("Key:"+RB.Key+" Value:"+RB.Value);
                        var tempObj = new GameObject("Wind_"+RB.Key);
                        var _lineRenderer = tempObj.AddComponent<LineRenderer>();
                        bodyLineDebug[RB.Key]=initBodyLineRender(_lineRenderer);
                        bodyLineDebug[RB.Key].SetVertexCount(0);
                        //drawBodyVector(controllerWindForce[RB.Key], bodyLineDebug[RB.Key]);
                    }
                    
                }
            }
            catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
        }

        public void toggleDebugLines(bool arg)
        {
            try
            {
                foreach(KeyValuePair<string,LineRenderer> elem in bodyLineDebug){
                    if(arg)
                    {
                        bodyLineDebug[elem.Key].SetVertexCount(2);
                    }
                    else
                    {
                        bodyLineDebug[elem.Key].SetVertexCount(0);
                    }
            }
                
            }
            catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}   
        }

        public void showAllLinesObj()
        {
            object[] obj = GameObject.FindObjectsOfType(typeof (LineRenderer));
                foreach (object o in obj)
                {
                    LineRenderer atom = (LineRenderer) o;
                    {
                        SuperController.LogMessage(atom.name);
                    }
                }
        }

        protected void OnDestroy()
        {
            //Destroying debug lines
            Destroy(_lineRenderer);
            destroyAllLines();
            
            turnWindOff_Clothes();
            turnWindOff_Hair();
            if (SuperController.singleton)
                SuperController.singleton.onAtomUIDRenameHandlers -= new SuperController.OnAtomUIDRename(OnAtomRename);
        }
    }

}
